<cfimport prefix="ui" taglib="tags/ui" />

<cfparam name="attributes.message" default="" />

<cfoutput>
<script type="text/javascript">
function updateLastPrice(field, li) {
	var product = field.value;
	if (typeof product != "string" || product.length <= 2) {
		return;
	}
	new Ajax.Request(
		"#self##xfa.f_lastPrice#",
		{
			postBody: {
				product: product
			},
			onComplete: function(t) {
				if ($("f_price").value == "") {
					$("f_price").value = t.responseText.replace(/(^ +)|( +$)/g, "");
					$("f_price").select();
				}
			}
		}
	);
}
function computeTotal() {
	var quantity = parseFloat($F("f_quantity"));
	var price = parseFloat($F("f_price"));
	if (! isNaN(quantity) && ! isNaN(price)) {
		$("f_total").value = Math.round(quantity * price * 100) / 100;
	}
}
function computeQuantity() {
	var total = parseFloat($F("f_total"));
	var price = parseFloat($F("f_price"));
	if (! isNaN(total) && ! isNaN(price)) {
		$("f_quantity").value = Math.round(total / price * 100) / 100;
	}
}
</script>
<cfswitch expression="#attributes.message#">
	<cfcase value="success"><p class="success">#getMessage("addLineItem.submitMessage.success")#</p></cfcase>
	<cfcase value="validation"><p class="error">#getMessage("addLineItem.submitMessage.validation")#</p></cfcase>
</cfswitch>
<form method="post" action="#self##xfa.submit#" class="f-wrap-1">
	<div class="req"><b>*</b> #getMessage("form.requiredField")#</div>
	<fieldset>
		<h3>#getMessage("addLineItem.title")#</h3>

		<label for="f_product"><b><span class="req">*</span>#getMessage("addLineItem.label.product")#:</b>
			<ui:combobox name="product" id="f_product" datasourceUrl="#self##xfa.f_productNames#" value="#attributes.product#" onupdate="updateLastPrice" /><br />
		</label>

		<label for="f_price"><b><span class="req">*</span>#getMessage("addLineItem.label.price")#:</b>
			<input name="price" id="f_price" value="#attributes.price#" style="text-align:right;width:5em;" /> &nbsp; (#getMessage("addLineItem.notes.price")#)<br />
		</label>

		<label for="f_quantity"><b><span class="req">*</span>#getMessage("addLineItem.label.quantity")#:</b>
			<input name="quantity" id="f_quantity" value="#attributes.quantity#" style="text-align:right;width:3em;" onkeyup="computeTotal();" onblur="computeTotal();" /><br />
		</label>

		<label for="f_total"><b>#getMessage("addLineItem.label.total")#:</b>
			<input id="f_total" style="text-align:right;width:3em;" onkeyup="computeQuantity();" onblur="computeQuantity();" /><br />
		</label>

		<div class="f-submit-wrap">
			<input type="submit" value="#getMessage('form.button.submit')#" class="f-submit" /><br />
			<input type="hidden" name="purchaseId" value="#attributes.purchaseId#" />
		</div>
	</fieldset>
</form>
<script type="text/javascript">
$("f_product").focus();
</script>
</cfoutput>