<cfimport prefix="ui" taglib="tags/ui" />

<cfparam name="request.requiresScriptaculous" default="false" />
<cfparam name="request.requiresPrototype" default="#request.requiresScriptaculous#" />

<cfoutput>
<html>
<head>
	<title>#getMessage("app.title")#</title>
	<!-- Mollio -->
	<link rel="stylesheet" type="text/css" href="mollio/css/main.css" media="screen" />
	<link rel="stylesheet" type="text/css" href="mollio/css/print.css" media="print" />
	<!--[if lte IE 6]>
	<link rel="stylesheet" type="text/css" href="mollio/css/ie6_or_less.css" />
	<![endif]-->
	<script type="text/javascript" src="mollio/js/common.js"></script>
	<!-- application -->
	<link rel="stylesheet" href="style.css" type="text/css" />
	<cfif request.requiresPrototype>
		<script type="text/javascript" src="prototype/prototype.js"></script>
	</cfif>
	<cfif request.requiresScriptaculous>
		<script type="text/javascript" src="scriptaculous/scriptaculous.js"></script>
	</cfif>
</head>
<cfset hasSidebar = structKeyExists(variables, "sidebar") AND len(trim(sidebar)) GT 0 />
<body id="<cfif hasSidebar>type-d<cfelse>type-a</cfif>">
<div id="wrap">
	<div id="header">
		<div id="site-name">#getMessage("app.title")#</div>
		<div id="search">
			<cfset names = application.configurationRegistry.getConfigurationNames() />
			<cfif listLen(names) GT 1>
				<form method="get" action="#self#">
				<cfif cgi.request_method EQ "GET">
					<cfloop collection="#url#" item="i">
						<cfif i NEQ application.configurationRegistry.CONFIGURATION_SWITCH_FIELD>
							<input type="hidden" name="#i#" value="#url[i]#" />
						</cfif>
					</cfloop>
				</cfif>
				<label for="config">Configuration:</label><br />
				<select name="#application.configurationRegistry.CONFIGURATION_SWITCH_FIELD#" id="config" onchange="this.form.submit();">
					<cfset active = application.configurationRegistry.getActiveConfigurationName() />
					<cfloop list="#names#" index="name">
						<option<cfif name EQ active> selected="selected"</cfif>>#name#</option></cfloop>
				</select>
				</form>
			</cfif>
		</div>
		<ul id="nav">
			<li><a href="#self##xfa.home#">#getMessage("app.nav.home")#</a></li>
			<li><a href="#self##xfa.addPurchase#">#getMessage("app.nav.addPurchase")#</a></li>
			<li><a href="#self##xfa.viewPurchases#">#getMessage("app.nav.viewPurchases")#</a></li>
			<li><a href="#self##xfa.viewProducts#">#getMessage("app.nav.viewProducts")#</a></li>
			<li><a href="#self##xfa.viewCategories#">#getMessage("app.nav.viewCategories")#</a></li>
			<li><a href="#self##xfa.viewLocations#">#getMessage("app.nav.viewLocations")#</a></li>
		</ul>
	</div>
	<div id="content-wrap">
		<div id="content">
			#body#

			<div id="footer">
				Copyright 2006<cfif year(now()) NEQ 2006>-#year(now())#</cfif> <a href="http://www.barneyb.com/">Barney Boisvert</a>.
			</div>
		</div>
		<cfif hasSidebar>
			<div id="sidebar">
				#sidebar#
			</div>
		</cfif>
	</div>
</div>
</body>
</html>
</cfoutput>